#include "server/types.h"
#include <server/response.h>

#include <civetweb.h>

void res_null_req(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 400 Bad Request\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"error\":\"null request\"}");
}
void res_must_get(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 405 Method Not Allowed\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"error\":\"must send get request\"}");
}
void res_must_post(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 405 Method Not Allowed\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"error\":\"must send post request\"}");
}
void res_need_token(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 400 Bad Request\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"error\":\"need token\"}");
}
void res_unauth(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 401 Unauthorized\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"error\":\"unauthorized\"}");
}
void res_check_exist_fail(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 500 Internal Server Error\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"error\":\"failed to check user existence\"}");
}
void res_user_exist(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 409 Conflict\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"error\":\"user already exists\"}");
}
void res_not_exist(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 404 Not Found\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"error\":\"user does not exist\"}");
}
void res_check_permission_fail(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 500 Internal Server Error\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"error\":\"failed to check user permission\"}");
}
void res_permission_denied(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 403 Forbidden\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"error\":\"permission denied\"}");
}
void res_need_user_id(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 400 Bad Request\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"error\":\"need user_id\"}");
}
void res_need_password(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 400 Bad Request\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"error\":\"need password\"}");
}

void res_auth(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 200 OK\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"success\":\"auth\"}");
}

void res_delete_account_fail(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 500 Internal Server Error\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"error\":\"failed to delete account\"}");
}
void res_delete_account(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 200 OK\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"success\":\"delete account success\"}");
}

void res_login_fail(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 500 Internal Server Error\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"error\":\"failed to login\"}");
}
void res_incorrect(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 401 Unauthorized\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"error\":\"incorrect password or user id\"}");
}
void res_login(mg_connection* conn, const char* token)
{
    mg_printf(conn,
              "HTTP/1.1 200 OK\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"success\":\"login success\", \"token\":\"%s\"}",
              token);
}

void res_register_fail(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 500 Internal Server Error\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"error\":\"failed to register\"}");
}
void res_register(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 200 OK\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"success\":\"registration success\"}");
}

void res_repasswd_fail(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 500 Internal Server Error\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"error\":\"failed to repasswd account\"}");
}
void res_repasswd(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 200 OK\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"success\":\"repasswd account success\"}");
}

void res_logout_fail(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 500 Internal Server Error\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"error\":\"failed to logout\"}");
}
void res_logout(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 200 OK\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"success\":\"logout success\"}");
}

void res_permission(mg_connection* conn, int permission)
{
    mg_printf(conn,
              "HTTP/1.1 200 OK\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"success\":\"query success\", \"permission\":\"%d\"}",
              permission);
}

void res_repermission_fail(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 500 Internal Server Error\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"error\":\"failed to repermission\"}");
}
void res_repermission(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 200 OK\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"success\":\"repermission success\"}");
}
void res_need_action(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 400 Bad Request\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"error\":\"need action specification\"}");
}

void res_bad_action(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 400 Bad Request\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"error\":\"bad action\"}");
}

void res_need_xxx(mg_connection* conn, const char* xxx)
{
    mg_printf(conn,
              "HTTP/1.1 400 Bad Request\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"error\":\"need %s\"}",
              xxx);
}

void res_500(mg_connection* conn, const char* error)
{
    mg_printf(conn,
              "HTTP/1.1 500 Internal Server Error\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"error\":\"%s\"}",
              error);
}

void res_404(mg_connection* conn, const char* error)
{
    mg_printf(conn,
              "HTTP/1.1 404 Not Found\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"error\":\"%s\"}",
              error);
}

void res_200(mg_connection* conn, const char* success)
{
    mg_printf(conn,
              "HTTP/1.1 200 OK\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"success\":\"%s\"}",
              success);
}

void res_auth_fail(mg_connection* conn)
{
    mg_printf(conn,
              "HTTP/1.1 500 Internal Server Error\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"error\":\"failed to authorize\"}");
}

void res_add_problem(mg_connection* conn, int id)
{
    mg_printf(conn,
              "HTTP/1.1 200 OK\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"success\":\"add problem success\", \"id\":%d}",
              id);
}

void res_query_problem(mg_connection* conn, const char* problem, const char* check_error)
{
    mg_printf(conn,
              "HTTP/1.1 200 OK\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"success\":\"query problem success\", \"problem\":\"%s\", \"check_error\":%s}",
              problem,
              check_error);
}
void res_query_problem2(mg_connection* conn, const char* problem, const char* answer, const char* check_error)
{
    mg_printf(conn,
              "HTTP/1.1 200 OK\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"success\":\"query problem success\", \"problem\":\"%s\",\"answer\":\"%s\", \"check_error\":%s}",
              problem,
              answer,
              check_error);
}
void res_check_answer(mg_connection* conn, int flag)
{
    mg_printf(conn,
              "HTTP/1.1 200 OK\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"success\":\"success to check\", \"result\":%s}",
              flag ? "true" : "false");
}
void res_all_problems(mg_connection* conn, const char* problems)
{
    mg_printf(conn,
              "HTTP/1.1 200 OK\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"success\":\"success to get all the problems\", \"result\":%s}",
              problems);
}

void res_get_record(mg_connection* conn, const char* record)
{
    mg_printf(conn,
              "HTTP/1.1 200 OK\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"success\":\"success to get the record\", \"record\":%s}",
              record);
}

void res_all_records(mg_connection* conn, const char* records)
{
    mg_printf(conn,
              "HTTP/1.1 200 OK\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"success\":\"success to get all records\", \"records\":%s}",
              records);
}

void res_all_records_by(mg_connection* conn, const char* records)
{
    mg_printf(conn,
              "HTTP/1.1 200 OK\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"success\":\"success to get all records by the user\", \"records\":%s}",
              records);
}

void res_all_records_of(mg_connection* conn, const char* records)
{
    mg_printf(conn,
              "HTTP/1.1 200 OK\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"success\":\"success to get all records of the problem\", \"records\":%s}",
              records);
}

void res_records_count(mg_connection* conn, int count)
{
    mg_printf(conn,
              "HTTP/1.1 200 OK\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"success\":\"success to get the records count\", \"result\":%d}",
              count);
}

void res_add_set(mg_connection* conn, int id)
{
    mg_printf(conn,
              "HTTP/1.1 200 OK\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"success\":\"success to add a new set\", \"id\":%d}",
              id);
}

void res_get_set(mg_connection* conn, const char* set)
{
    mg_printf(conn,
              "HTTP/1.1 200 OK\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"success\":\"success to get the set\", \"set\":%s}",
              set);
}

void res_all_sets(mg_connection* conn, const char* sets)
{
    mg_printf(conn,
              "HTTP/1.1 200 OK\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"success\":\"success to get all sets\", \"sets\":%s}",
              sets);
}

void res_sets_count(mg_connection* conn, int count)
{
    mg_printf(conn,
              "HTTP/1.1 200 OK\r\n"
              "Content-Type: application/json\r\n"
              "Access-Control-Allow-Origin: *\r\n\r\n"
              "{\"success\":\"success to get the sets count\", \"result\":%d}",
              count);
}
